struct CharTemplate
{
	int AttributeType;
	int MinLevel;
	int MaxLevel;
	int* Class;
	int ClassCount;
	int* AttributePreset;
	int Monster;
	int MonsterName;
	int Mixed;
	int Race;
};

#define AttackNone 0
#define AttackSingleWeapon 1
#define AttackTwoWeapons 2
#define AttackBiWeapon 3
#define AttackBow 4
#define AttackMonster 5

#define EquipWeapon 0
#define EquipArmor 1
#define EquipShield 2
#define EquipRing 3
#define EquipAmulet 4
#define EquipCloak 5
#define EquipBoots 6
#define EquipBelt 7
#define EquipGloves 8
#define EquipHelmet 9
#define EquipMoney 10
#define EquipArrows 11

struct clsMonster
{
	char Name[256];
	int CR;
	int Type;
	int Size;
	int Epic;
	int HD;
	int HDType;
	int TPBonus;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int Attr[6];
	int AC;
	int HDMin;
	int HDMax;
	int HDInc;
	int HDInc2;
	int Init;
	int Speed;
	int OrgMin;
	int OrgMax;
	int Mixed;
	int Treasure;
	int AttackBonus[6];
	int AttackNumber[6];
	int AttackRed[6];
	int DamageA[6];
	int DamageB[6];
	int DamageC[6];
	char AttackType[6][32];
	int AlternateAttack[6];
	int AttackCount;
	int Feats[6];
	int FeatCount;
	int Skills[7];
	int SkillLevels[7];
	int SkillCount;
};

struct clsPower
{
	char Name[256];
	int Psion;
	int PsychicW;
	int Attribute;
};

struct clsEffect
{
	char Name[256];
	int Weapon;
	int Armor;
	int Shield;
	int Helmet;
	int Gloves;
	int Boots;
	int Belt;
	int Cloak;
	int Ring;
	int Amulet;
	int Fight;
	int Magic;
	int Shadow;
	int Multi;
	int Cost;
	int Cost2;
	int Quality;
};

struct clsSpell
{
	char Name[256];
	int Probability;
	int ClassLevels[128];
	int DomainCount;
	int DomainLevel;
	int Domains[2];
	int School;
};

struct clsEquip
{
	char Name[256];
	int EquipType;
	int Enhencement;
	int Effect[6];
	char EffectDesc[6][256];
	int EffectCount;
	int EffectCountA;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int AttackType;
	int Probability[128];
	int RaceProbability[128];
	int StdProb;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int AttackBonus;
	int AttackBonusA;
	int TwoWeapon;
	int TwoWeaponSecond;
	int TwoHand;
	int MaxStr;
	char DescText[1024];
	int Primary;
	int Secondary;
	int Value;
	int Adamantine;
	int Mithril;
	int ShieldUsed;
	int UseMaxEnh;
	int IncludeInTreasure;
};

struct clsRace
{
	char Name[256];
	int Probability;
	int Size;
	int PreferedAttackType;
};

struct clsChar
{
	int MonsterTWType;
	int MonsterSize;
	int HG;
	int Attributes[6];
	int Mods[6];
	int ClassCount;
	int Classes[32];
	int DummyClass[32];
	int Level;
	int Levels[32];
	int LevelsClassic[32];
	int Life;
	int LifeBonus;
	int GA;
	int GASize;
	int GAMelee;
	int GAShot;
	int GAMeleeAttr;
	int GAShotAttr;
	int GAMeleeRest;
	int GAShotRest;
	int GAEpic;
	int RWEpic;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int RWRefBase;
	int RWWilBase;
	int RWZaehBase;
	int RWRefAttr;
	int RWWilAttr;
	int RWZaehAttr;
	int RWRefMage;
	int RWWilMage;
	int RWZaehMage;
	int RWRefRest;
	int RWWilRest;
	int RWZaehRest;
	int FeatCount;
	int Feats[64];
	int FeatDependancy[64];
	int FeatDone[64];
	CharTemplate* CreationTemplate;
	int AttackType[2];
	int AttackTypeCount;
	clsEquip Equipment[32];
	int EquipCount;
	int Skills[512];
	int SkillLevels[512];
	int SkillLevels2[512];
	int SkillCount;
	int SkillCountReal;
	int SkillPoints;
	int Race;
	int SkillRequired[512];
	int SpellsKnownCount[32][10];
	int SpellList[32][10][10];
	int SpellsPerDayCount[32][10];
	int SpellListCount[32][10];
	int Domains[2];
	int DomainSpells[10];
	int DomainSpellCount;
	int Specialised;
	int School;
	int SchoolForbidden[9];
	char CharText[65536];
	char CharTextPrimary[65536];
	char CharTextSecondary[65536];
	char CharTextTwo[65536];
	int WeaponArmorShieldFeats;
	int AC;
	int ACArmor;
	int ACShield;
	int ACDex;
	int ACSize;
	int ACRest;
	float Range;
	int MR;
	int MRBonus;
	int againstMR;
	int PR;
	int againstPR;
	int Attacks;
	int Attacks2;
	int AttacksOpportunity;
	int MonkAttacks;
	int SpecialAbbilities;
	int Initiative;
	int InitiativeRest;
	int InitiativeDex;
	int ArmorMalus;
	int MaxDex;
	int RingMax;
	int BonusSpells;
	int BonusSpellLevelMin;
	int BonusSpellLevelMax;
	int AttackMod;
	int DmgMod;
	int Money;
	int MoneyRest;
	int Treasure;
	int TreasureLeft;
	char UnarmedDamage[32];
	int PowerPoints;
	int MainDisciple;
	int CrystalCount;
	int CombatModes;
	int dart;
	int Monster;
	int MonsterName;
	int MonsterType;
	int MAttackBonus[6];
	int MAttackNumber[6];
	int MAttackRed[6];
	int MDamageA[6];
	int MDamageB[6];
	int MDamageC[6];
	char MAttackType[6][32];
	int MAlternateAttack[6];
	int MAttackCount;
	int MSize;
	int MaxEnh;
	int HighestSpell;
	int CRPosCount;
	int CRPosHD[32];
	int CRPosTemplate[32];
	int CRPosCR[32];
	int IsLich;
	int IsVampire;
	int SpellFailure;
	int Profiled;
	int ProfileStrength;
	int Profile;
	int Mixed;
	int MixedHG;
	int SneakDmg;
};

struct clsCharSource
{
	int Count;
	char Name[256];
	int TW;
	int AttributePriority[6];
	int Probability;
	int GA;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int PreferedAttack;
	int Skills;
	int Prestige;
	int MaxLevel;
	int MaxLevelA;
};

struct clsFeatSource
{
	char Name[256];
	int Probability[128];
	int MultipleTimes;
	int Epic;
};

struct clsSkills
{
	char Name[256];
	int Prob[128];
	int Attr;
};

struct clsSource
{
	clsCharSource*	CharSource;
	int CharSourceCount;
	clsFeatSource* FeatSource;
	int FeatSourceCount;
	clsEquip* EquipSource;
	int EquipSourceCount;
	clsSkills* SkillSource;
	int SkillSourceCount;
	clsRace* RaceSource;
	int RaceSourceCount;
	clsSpell* SpellSource;
	int SpellSourceCount;
	clsPower* PowerSource;
	int PowerSourceCount;
	clsEffect* EffectSource;
	int EffectSourceCount;
	clsMonster* MonsterSource;
	int MonsterSourceCount;
	char SchoolSource[9][256];
	int SchoolSourceCount;
	char SizeSource[10][256];
	int SizeSourceCount;
	char MonsterTypeSource[17][256];
	int MonsterTypeSourceCount;
	char DomainSource[22][256];
	int DomainSourceCount;
	int InitCharSource();
	char AttributeNames[6][32];
	char Templates[11][32];
	int TemplateCount;
};

clsSource Source;