void SetEquipSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, dmg1, dmg2, size, critical, criticalm, attack, type, etype, prob, armor, maxdex, malus, spell, metal, valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		dmg1 = GetValNumber(Vals, "Damage1", Number);
		dmg2 = GetValNumber(Vals, "Damage2", Number);
		size = GetValNumber(Vals, "Size", Number);
		critical = GetValNumber(Vals, "Critical", Number);
		criticalm = GetValNumber(Vals, "CriticalM", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		type = GetValNumber(Vals, "Type", Number);
		etype = GetValNumber(Vals, "EquipType", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		armor = GetValNumber(Vals, "Armor", Number);
		maxdex = GetValNumber(Vals, "MaxDex", Number);
		malus = GetValNumber(Vals, "Malus", Number);
		spell = GetValNumber(Vals, "SpellF", Number);
		metal = GetValNumber(Vals, "Metal", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Equipment Source Database\n");
		quitprog();
	}

	strcpy(((clsEquip*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[dmg1], "%d", &(((clsEquip*) TargetStruct)->Damage1));
	sscanf(Vals[dmg2], "W%d", &(((clsEquip*) TargetStruct)->Damage2));
	(((clsEquip*) TargetStruct)->Damage3) = 0;
	sscanf(Vals[size], "%d", &(((clsEquip*) TargetStruct)->Size));
	sscanf(Vals[critical], "%d", &(((clsEquip*) TargetStruct)->Critical));
	sscanf(Vals[criticalm], "%d", &(((clsEquip*) TargetStruct)->CriticalMultiplier));
	sscanf(Vals[attack], "%d", &(((clsEquip*) TargetStruct)->AttackType));
	sscanf(Vals[type], "%d", &(((clsEquip*) TargetStruct)->Type));
	sscanf(Vals[etype], "%d", &(((clsEquip*) TargetStruct)->EquipType));	
	sscanf(Vals[prob], "%d", &(((clsEquip*) TargetStruct)->StdProb));	
	sscanf(Vals[armor], "%d", &(((clsEquip*) TargetStruct)->Armor));	
	sscanf(Vals[maxdex], "%d", &(((clsEquip*) TargetStruct)->MaxDex));	
	sscanf(Vals[malus], "%d", &(((clsEquip*) TargetStruct)->Malus));	
	sscanf(Vals[spell], "%d", &(((clsEquip*) TargetStruct)->SpellFailure));	
	sscanf(Vals[metal], "%d", &(((clsEquip*) TargetStruct)->Metallic));
	((clsEquip*) TargetStruct)->Adamantine = 0;
	((clsEquip*) TargetStruct)->Mithril = 0;
	((clsEquip*) TargetStruct)->UseMaxEnh = 0;
}

void SetWProbSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i, j;
	static int ClassPosition[128];
	static int RacePosition[128];
	static int name, valcount;

	TargetStruct = 0;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name, Number);
		}
		for (i = 0;i < Source.RaceSourceCount;i++)
		{
			RacePosition[i] = GetValNumber(Vals, Source.RaceSource[i].Name, Number);
		}
		name = GetValNumber(Vals, "Name", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Equipment Source Database\n");
		quitprog();
	}

	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (strcmp(Source.EquipSource[i].Name, Vals[name]) == 0)
		{
			for (j = 0;j < Source.CharSourceCount;j++)
			{
				sscanf(Vals[ClassPosition[j]], "%d", &Source.EquipSource[i].Probability[j]);
			}
			for (j = 0;j < Source.RaceSourceCount;j++)
			{
				sscanf(Vals[RacePosition[j]], "%d", &Source.EquipSource[i].RaceProbability[j]);
			}
			return;
		}
	}
	printf("Could not find Equipment %s\n", Vals[0]);
	quitprog();
}

int GetEquipNumber(char* EquipName)
{
	int i;
	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (strcmp(EquipName, Source.EquipSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Equipment not found(%s)\n", EquipName);
	quitprog();
	return(0);
}

int EquipSourceInit()
{
	int i;
	int ProbCount;
	FILE *fChar, *fChar2;

	if (DebugOutput) {printf("Opening Equipment List (%s)\t\t", EquipFile);}
	fChar = fopen(EquipFile, "r");
	fChar2 = fopen(WProbFile, "r");
	if (fChar == 0 || fChar2 == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Equipment List\t\t\t\t");}
	ProcessLine(fChar, &SetEquipSource, NULL, true);
	ProcessLine(fChar2, &SetWProbSource, NULL, true);
	Source.EquipSourceCount = CountSetLines(fChar);
	ProbCount = CountSetLines(fChar2);
	if (DebugOutput) {printf("%d\n", Source.EquipSourceCount);}
	Source.EquipSource = new clsEquip[Source.EquipSourceCount];
	if (Source.EquipSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		ProcessLine(fChar, &SetEquipSource, &Source.EquipSource[i], false);
		if (DebugOutput) {printf("%s ", Source.EquipSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	for (i = 0;i < ProbCount;i++)
	{
		ProcessLine(fChar2, &SetWProbSource, NULL, false);
	}

	fclose(fChar);
	fclose(fChar2);

	return(0);
}

void EquipSourceExit()
{
	delete[] Source.EquipSource;
}