int GetDomainNumber(char* Domain)
{
	int i;
	for (i = 0;i < Source.DomainSourceCount;i++)
	{
		if (strcmp(Source.DomainSource[i], Domain) == 0)
		{
			return(i);
		}
	}
	printf("Domain not found: %s\n", Domain);
	quitprog();
	return(0);
}

int GetSchoolNumber(char* School)
{
	int i;
	for (i = 0;i < Source.SchoolSourceCount;i++)
	{
		if (strcmp(Source.SchoolSource[i], School) == 0)
		{
			return(i);
		}
	}
	printf("School not found: %s\n", School);
	quitprog();
	return(0);
}

void SetSpellSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;
	static int ClassPosition[128];
	static int DomainPos[2], DomainLevelPos, SchoolPos, ProbabilityPos, name;

	if (Number != 12)
	{
		printf("Invalid Number of Arguments in Spell Source Database\n");
		quitprog();
	}
	
	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			if (i == GetCharNumber("Magier") || i == GetCharNumber("Hexenmeister"))
			{
				ClassPosition[i] = GetValNumber(Vals, "Magier", Number);
			}
			else if (i == GetCharNumber("Kleriker"))
			{
				ClassPosition[i] = GetValNumber(Vals, "Kleriker", Number);
			}
			else if (i == GetCharNumber("Druide"))
			{
				ClassPosition[i] = GetValNumber(Vals, "Druide", Number);
			}
			else if (i == GetCharNumber("Barde"))
			{
				ClassPosition[i] = GetValNumber(Vals, "Barde", Number);
			}
			else if (i == GetCharNumber("Paladin"))
			{
				ClassPosition[i] = GetValNumber(Vals, "Paladin", Number);
			}
			else if (i == GetCharNumber("Waldlufer"))
			{
				ClassPosition[i] = GetValNumber(Vals, "Waldlufer", Number);
			}
			else
			{
				ClassPosition[i] = -1;
			}
		}

		DomainPos[0] = GetValNumber(Vals, "Domne", Number);
		DomainPos[1] = GetValNumber(Vals, "Domne2", Number);
		DomainLevelPos = GetValNumber(Vals, "DomneL", Number);
		SchoolPos = GetValNumber(Vals, "Schule", Number);
		ProbabilityPos = GetValNumber(Vals, "Probability", Number);
		name = GetValNumber(Vals, "Name", Number);

		return;
	}
	strcpy(((clsSpell*) TargetStruct)->Name, Vals[name]);
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (ClassPosition[i] != -1)
		{
			sscanf(Vals[ClassPosition[i]], "%d", &(((clsSpell*) TargetStruct)->ClassLevels[i]));
		}
		else
		{
			((clsSpell*) TargetStruct)->ClassLevels[i] = -1;
		}
	}
	((clsSpell*) TargetStruct)->DomainCount = 2;
	if (strcmp(Vals[DomainPos[1]], "-") == 0)
	{
		((clsSpell*) TargetStruct)->DomainCount = 1;
	}
	if (strcmp(Vals[DomainPos[0]], "-") == 0)
	{
		((clsSpell*) TargetStruct)->DomainCount = 0;
	}

	for (i = 0;i < ((clsSpell*) TargetStruct)->DomainCount;i++)
	{
		((clsSpell*) TargetStruct)->Domains[i] = GetDomainNumber(Vals[DomainPos[i]]);
	}
		
	sscanf(Vals[DomainLevelPos], "%d", &(((clsSpell*) TargetStruct)->DomainLevel));
	((clsSpell*) TargetStruct)->School = GetSchoolNumber(Vals[SchoolPos]);
	sscanf(Vals[ProbabilityPos], "%d", &(((clsSpell*) TargetStruct)->Probability));
}

int GetSpellNumber(char* SpellName)
{
	int i;
	for (i = 0;i < Source.SpellSourceCount;i++)
	{
		if (strcmp(SpellName, Source.SpellSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Spell not found(%s)\n", SpellName);
	quitprog();
	return(0);
}

int SpellSourceInit()
{
	int i;
	FILE *fChar;

	if (DebugOutput) {printf("Opening Spell List (%s)\t\t\t", SpellFile);}
	fChar = fopen(SpellFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Spell List\t\t\t\t");}
	ProcessLine(fChar, &SetSpellSource, NULL, true);
	Source.SpellSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.SpellSourceCount);}
	Source.SpellSource = new clsSpell[Source.SpellSourceCount];
	if (Source.SpellSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.SpellSourceCount;i++)
	{
		ProcessLine(fChar, &SetSpellSource, &Source.SpellSource[i], false);
		if (DebugOutput) {printf("%s ", Source.SpellSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void SpellSourceExit()
{
	delete[] Source.RaceSource;
}