int CountFeats(clsChar* TargetStruct, int FeatNumber, int featsyet)
{
	int i, temp;
	temp = 0;
	for (i = 0;i < featsyet;i++)
	{
		if (TargetStruct->Feats[i] == FeatNumber)
		{
			temp++;
		}
	}
	return(temp);
}

bool FeatPresent(clsChar* TargetStruct, int FeatNumber, int featsyet, int FeatDep)
{
	int i;
	
	for (i = 0;i < featsyet;i++)
	{
		if (TargetStruct->Feats[i] == FeatNumber &&
			(FeatDep == -2 || TargetStruct->FeatDependancy[i] == FeatDep || TargetStruct->FeatDependancy[i] == -1))
		{
			return(true);
		}
	}
	return(false);
}

bool CheckFinessPossible(clsChar* TargetStruct)
{
	int i;
	for (i = 0;i < TargetStruct->EquipCount;i++)
	{
		if (strcmp(TargetStruct->Equipment[i].Name, "Rapier") == 0 || strcmp(TargetStruct->Equipment[i].Name, "Krummsbel") == 0)
		{
			return(true);
		}
	}
	return(false);
}

bool FeatPossible(clsChar* TargetStruct, int FeatNumber, int featsyet)
{
	int i;
	clsChar TestChar;
	ClearChar(&TestChar);
	TestChar.FeatCount = 1;
	TestChar.Feats[0] = FeatNumber;
	SetFeatSkills(&TestChar);
	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (TestChar.SkillRequired[i] > TargetStruct->Level + 3)
		{
			return(false);
		}
	}

	if (GetFeatNumber("Anfhren") == FeatNumber)
	{
		return(TargetStruct->Level >= 6 ? true : false);
	}

	if (GetFeatNumber("Ausweichen") == FeatNumber)
	{
		return(TargetStruct->Attributes[1] >= 13 ? true : false);
	}

	if (GetFeatNumber("Beweglichkeit") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Ausweichen"), featsyet));
	}

	if (GetFeatNumber("TnzelnderAngriff") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Beweglichkeit"), featsyet));
	}

	if (GetFeatNumber("Beidhndigkeit") == FeatNumber)
	{
		return(TargetStruct->Attributes[1] >= 15 ? true : false);
	}

	if (GetFeatNumber("AngriffImVorbeireiten") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BerittenerKampf"), featsyet));
	}

	if (GetFeatNumber("BerittenerFernkampf") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BerittenerKampf"), featsyet));
	}

	if (GetFeatNumber("Niederreiten") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BerittenerKampf"), featsyet));
	}

	if (GetFeatNumber("BeherzterSturmangriff") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("AngriffImVorbeireiten"), featsyet));
	}
	
	if (GetFeatNumber("DefensiveKampfweise") == FeatNumber)
	{
		return(TargetStruct->Attributes[3] >= 13 ? true : false);
	}

	if (GetFeatNumber("VerbessertesEntwaffnen") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("DefensiveKampfweise"), featsyet));
	}
	
	if (GetFeatNumber("VerbessertesZuFallBringen") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("DefensiveKampfweise"), featsyet));
	}

	if (GetFeatNumber("Wirbelwind") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("DefensiveKampfweise"), featsyet)
			&& FeatPresent(TargetStruct, GetFeatNumber("TnzelnderAngriff"), featsyet)
			&& (TargetStruct->GA >= 4 ? true : false));
	}
	
	if (GetFeatNumber("HeftigerAngriff") == FeatNumber)
	{
		return(TargetStruct->Attributes[0] >= 13 ? true : false);
	}

	if (GetFeatNumber("Doppelschlag") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("HeftigerAngriff"), featsyet));
	}

	if (GetFeatNumber("VerbesserterAnsturm") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("HeftigerAngriff"), featsyet));
	}

	if (GetFeatNumber("WaffeZerschmettern") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("HeftigerAngriff"), featsyet));
	}

	if (GetFeatNumber("Rundumschlag") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("Doppelschlag"), featsyet)
			&& (TargetStruct->GA >= 4 ? true : false));
	}

	if (GetFeatNumber("VerbesserterKampfMitZweiWaffen") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("Beidhndigkeit"), featsyet)
			&& FeatPresent(TargetStruct, GetFeatNumber("KampfMitZweiWaffen"), featsyet));
	}

	if (GetFeatNumber("Fernschuss") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), featsyet));
	}
	
	if (GetFeatNumber("Przisionsschuss") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), featsyet));
	}

	if (GetFeatNumber("SchnellesSchieen") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), featsyet)
			&& (TargetStruct->Attributes[1] >= 13 ? true : false));
	}

	if (GetFeatNumber("AusVollemLaufSchieen") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), featsyet)
			&& FeatPresent(TargetStruct, GetFeatNumber("Beweglichkeit"), featsyet)
			&& (TargetStruct->Attributes[1] >= 13 ? true : false));
	}
	
	if (GetFeatNumber("SchnelleWaffenbereitschaft") == FeatNumber)
	{
		return(TargetStruct->GA >= 1 ? true : false);
	}

	if (GetFeatNumber("Waffenspezialisierung") == FeatNumber)
	{
		return (
			(CountFeats(TargetStruct, GetFeatNumber("Waffenfokus"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("Waffenspezialisierung"), featsyet) ? true : false)
			&
			(TargetStruct->GA >= 4 ? true : false)
			);
	}

	if (GetFeatNumber("VerbesserterZauberfokus") == FeatNumber)
	{
		return (CountFeats(TargetStruct, GetFeatNumber("Zauberfokus"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("VerbesserterZauberfokus"), featsyet) ? true : false);
	}
	
	if (GetFeatNumber("VerbesserteDurschschlagende") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("DurschschlagendeZauber"), featsyet));
	}

	if (GetFeatNumber("Waffenfinesse") == FeatNumber)
	{
		return((TargetStruct->GA >= 1 ? true : false)
			&& (FeatPresent(TargetStruct, GetFeatNumber("Waffenfokus"), featsyet))
			&& (TargetStruct->Attributes[1] > TargetStruct->Attributes[0] ? true : false)
			&& (CheckFinessPossible(TargetStruct)));
			
	}

	if (GetFeatNumber("VerbesserterKritischerTreffer") == FeatNumber)
	{
		return((TargetStruct->GA >= 8 ? true : false)
			&&  (CountFeats(TargetStruct, GetFeatNumber("Waffenfokus"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("VerbesserterKritischerTreffer"), featsyet) ? true : false)
			);
	}

	if (GetFeatNumber("GeschosseAbwehren") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet)
			&& (TargetStruct->Attributes[1] >= 13 ? true : false));
	}

	if (GetFeatNumber("BetubenderSchlag") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet)
			&& (TargetStruct->Attributes[1] >= 13 ? true : false)
			&& (TargetStruct->GA >= 13 ? true : false));
	}

	if (GetFeatNumber("ZustzlichesVertreiben") == FeatNumber)
	{
		return(IsClass(TargetStruct, GetCharNumber("Kleriker")) || IsClass(TargetStruct, GetCharNumber("Paladin")));
	}

	if (GetFeatNumber("PsionicDodge") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Ausweichen"), featsyet));
	}

	if (GetFeatNumber("Talented") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("InnerStrength"), featsyet));
	}
	if (GetFeatNumber("BodyFuel") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BodyFuel"), featsyet));
	}
	if (GetFeatNumber("TriggerPower") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BodyFuel"), featsyet));
	}
	if (GetFeatNumber("MentalAdversary") == FeatNumber)
	{
		return(TargetStruct->Attributes[5] >= 13 ? true : false);
	}
	
	if (GetFeatNumber("DisarmMind") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("MentalAdversary"), featsyet));
	}
	if (GetFeatNumber("MentalLeap") == FeatNumber)
	{
		return(TargetStruct->Attributes[0] >= 13 ? true : false);
	}
	if (GetFeatNumber("PsionicShot") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), featsyet));
	}
	if (GetFeatNumber("FellShot") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsionicShot"), featsyet) && TargetStruct->GA >= 3);
	}
	if (GetFeatNumber("ReturnShot") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsionicShot"), featsyet) && TargetStruct->GA >= 5);
	}
	if (GetFeatNumber("GreatSunder") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("HeftigerAngriff"), featsyet));
	}
	if (GetFeatNumber("PsionicWeapon") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("HeftigerAngriff"), featsyet));
	}
	if (GetFeatNumber("DeepImpact") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsionicWeapon"), featsyet));
	}
	if (GetFeatNumber("GreaterPsionicFocus") == FeatNumber)
	{
		return (CountFeats(TargetStruct, GetFeatNumber("PsionicFocus"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("GreaterPsionicFocus"), featsyet) ? true : false);
	}
	if (GetFeatNumber("GreaterPowerPenetration") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsionicWeapon"), featsyet));
	}
	if (GetFeatNumber("PsionicFist") == FeatNumber)
	{
		return(TargetStruct->Attributes[0] >= 13 ? true : false);
	}
	if (GetFeatNumber("PowerTouch") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsionicFist"), featsyet));
	}
	if (GetFeatNumber("UnavoidableStrike") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsionicFist"), featsyet) && TargetStruct->GA >= 3);
	}
	if (GetFeatNumber("MindTrap") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("PsychicBastion"), featsyet));
	}
	if (GetFeatNumber("Psychoanalyst") == FeatNumber)
	{
		return(TargetStruct->Attributes[5] >= 13 ? true : false);
	}
	if (GetFeatNumber("PsychicInquisitor") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Psychoanalyst"), featsyet));
	}
	if (GetFeatNumber("RapidMetabolism") == FeatNumber)
	{
		return(TargetStruct->Attributes[2] >= 13 ? true : false);
	}
	if (GetFeatNumber("PsionicMetabolism") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("RapidMetabolism"), featsyet));
	}
	if (GetFeatNumber("SpeedofThought") == FeatNumber)
	{
		return(TargetStruct->Attributes[3] >= 13 ? true : false);
	}
	if (GetFeatNumber("PsionicCharge") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("SpeedofThought"), featsyet));
	}
	if (GetFeatNumber("UptheWalls") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("SpeedofThought"), featsyet));
	}
	if (GetFeatNumber("StandStill") == FeatNumber)
	{
		return(TargetStruct->Attributes[0] >= 13 ? true : false);
	}
	
	if (GetFeatNumber("AutomaticQuickenSpell") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("SchnellZaubern"), featsyet) && (TargetStruct->HighestSpell >= 9 ? true : false));
	}
	if (GetFeatNumber("AutomaticSilentSpell") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("LautlosZaubern"), featsyet) && (TargetStruct->HighestSpell >= 9 ? true : false));
	}
	if (GetFeatNumber("AutomaticStillSpell") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("GestenlosZaubern"), featsyet) && (TargetStruct->HighestSpell >= 9 ? true : false));
	}
	if (GetFeatNumber("BaneOfEnemies") == FeatNumber)
	{
		return((TargetStruct->Level / 5 + 1  >= 5 ? true : false));
	}
	if (GetFeatNumber("DeathOfEnemies") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BaneOfEnemies"), featsyet));
	}
	if (GetFeatNumber("PlantWildShape") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BeastWildShape"), featsyet));
	}
	if (GetFeatNumber("VerminWildShape") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BeastWildShape"), featsyet));
	}
	if (GetFeatNumber("MagicalBeastWildShape") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BeastWildShape"), featsyet) && (TargetStruct->Attributes[4] >= 25 ? true : false));
	}
	if (GetFeatNumber("DragonWildShape") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("BeastWildShape"), featsyet) && (TargetStruct->Attributes[4] >= 30 ? true : false));
	}
	if (GetFeatNumber("BlindingSpeed") == FeatNumber)
	{
		return((TargetStruct->Attributes[1] >= 25 ? true : false));
	}
	if (GetFeatNumber("BonusDomain") == FeatNumber)
	{
		return((TargetStruct->HighestSpell >= 9) && (TargetStruct->Attributes[4] >= 25 ? true : false));
	}
	if (GetFeatNumber("BulwarkOfDefense") == FeatNumber)
	{
		return((TargetStruct->Attributes[2] >= 25 ? true : false) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("DwarfD"))] >= 5 ? true : false));
	}
	if (GetFeatNumber("ChaoticRage") == FeatNumber)
	{
		return((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] >= 16 ? true : false));
	}
	if (GetFeatNumber("CombatArchery") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("Beweglichkeit"), featsyet));
	}
	if (GetFeatNumber("DamageReduction") == FeatNumber)
	{
		return((TargetStruct->Attributes[2] >= 21 ? true : false));
	}
	if (GetFeatNumber("HinderingSong") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("DefeningSong"), featsyet));
	}
	if (GetFeatNumber("DiminutiveWildShape") == FeatNumber)
	{
		return((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Druide"))] >= 15 ? true : false));
	}
	if (GetFeatNumber("FineWildShape") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("DiminutiveWildShape"), featsyet));
	}
	if (GetFeatNumber("DistantShot") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Fernschuss"), featsyet) && (TargetStruct->Attributes[1] >= 25 ? true : false));
	}
	if (GetFeatNumber("EnhanceSpell") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("ZauberMaximieren"), featsyet));
	}
	if (GetFeatNumber("EpicEndurance") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Abhrtung"), featsyet) && (TargetStruct->Attributes[2] >= 25 ? true : false));
	}
	if (GetFeatNumber("EpicEvasion") == FeatNumber)
	{
		return((TargetStruct->Attributes[1] >= 25 ? true : false));
	}
	if (GetFeatNumber("EpicInspiration") == FeatNumber)
	{
		return((TargetStruct->Attributes[5] >= 25 ? true : false));
	}
	if (GetFeatNumber("EpicLeadership") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Anfhren"), featsyet) && (TargetStruct->Attributes[5] >= 25 ? true : false));
	}
	if (GetFeatNumber("LegendaryCommander") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("EpicLeadership"), featsyet) && (TargetStruct->Attributes[2] >= 25 ? true : false));
	}

	if (GetFeatNumber("EpicSpellFocus") == FeatNumber)
	{
		return (CountFeats(TargetStruct, GetFeatNumber("VerbesserterZauberfokus"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("EpicSpellFocus"), featsyet) ? true : false);
	}
	if (GetFeatNumber("EpicSpellPenetration") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("VerbesserteDurschschlagende"), featsyet));
	}

	if (GetFeatNumber("EpicSpellcasting") == FeatNumber)
	{
		return((TargetStruct->HighestSpell >= 9 ? true : false));
	}

	if (GetFeatNumber("EpicWeaponFocus") == FeatNumber)
	{
		return (CountFeats(TargetStruct, GetFeatNumber("Waffenfokus"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("EpicWeaponFocus"), featsyet) ? true : false);
	}
	if (GetFeatNumber("EpicWeaponSpezialisation") == FeatNumber)
	{
		return (CountFeats(TargetStruct, GetFeatNumber("Waffenspezialisierung"), featsyet) > CountFeats(TargetStruct, GetFeatNumber("EpicWeaponSpezialisation"), featsyet) ? true : false);
	}

	if (GetFeatNumber("ExeptionalDeflection") == FeatNumber)
	{
		return ((TargetStruct->Attributes[1] >= 21 ? true : false) && (TargetStruct->Attributes[4] >= 19 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("GeschosseAbwehren"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet));
	}

	if (GetFeatNumber("FamiliarSpell") == FeatNumber)
	{
		return ((TargetStruct->Attributes[3] >= 25 ? true : false) || (TargetStruct->Attributes[4] >= 25 ? true : false));
	}

	if (GetFeatNumber("FastHealing") == FeatNumber)
	{
		return ((TargetStruct->Attributes[2] >= 25 ? true : false));
	}

	if (GetFeatNumber("FleetOfFoot") == FeatNumber)
	{
		return ((TargetStruct->Attributes[1] >= 21 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("Rennen"), featsyet));
	}

	if (GetFeatNumber("GargantuanWildShape") == FeatNumber)
	{
		return((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Druide"))] >= 15 ? true : false));
	}

	if (GetFeatNumber("ColossalWildShape") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("GargantuanWildShape"), featsyet));
	}

	if (GetFeatNumber("GreatSmiting") == FeatNumber)
	{
		return (IsClass(TargetStruct, GetCharNumber("Paladin")) || IsClass(TargetStruct, GetCharNumber("BlackG")));
	}
	
	if (GetFeatNumber("GreatSmiting") == FeatNumber)
	{
		return ((TargetStruct->HighestSpell >= 9 ? true : false));
	}

	if (GetFeatNumber("ImprovedAlignmentBaseCasting") == FeatNumber)
	{
		return ((TargetStruct->HighestSpell >= 9 ? true : false)
		&& (
			TargetStruct->Domains[0] == GetDomainNumber("Gutes")
			|| TargetStruct->Domains[1] == GetDomainNumber("Gutes")
			|| TargetStruct->Domains[0] == GetDomainNumber("Bses")
			|| TargetStruct->Domains[1] == GetDomainNumber("Bses")
			|| TargetStruct->Domains[0] == GetDomainNumber("Chaos")
			|| TargetStruct->Domains[1] == GetDomainNumber("Chaos")
			|| TargetStruct->Domains[0] == GetDomainNumber("Ordnung")
			|| TargetStruct->Domains[1] == GetDomainNumber("Ordnung")
		));
	}

	if (GetFeatNumber("ImprovedArrowOfDeath") == FeatNumber)
	{
		return ((TargetStruct->Attributes[1] >= 19 ? true : false) || (TargetStruct->Attributes[4] >= 19 ? true : false));
	}

	if (GetFeatNumber("ImprovedAuraOfCourage") == FeatNumber)
	{
		return ((TargetStruct->Attributes[5] >= 25 ? true : false));
	}

	if (GetFeatNumber("ImprovedCombatCasting") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("ImKampfZaubern"), featsyet));
	}

	if (GetFeatNumber("ImprovedCombatReflexes") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("Kampfreflexe"), featsyet) && (TargetStruct->Attributes[1] >= 21 ? true : false));
	}

	if (GetFeatNumber("ImprovedDarkvision") == FeatNumber)
	{
		return ((TargetStruct->Race == GetRaceNumber("Zwerg") || TargetStruct->Race == GetRaceNumber("Halbork") ? true : false));
	}

	if (GetFeatNumber("ImprovedElementalWildShape") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Druide"))] >= 15 ? true : false) && (TargetStruct->Attributes[4] >= 25 ? true : false));
	}

	if (GetFeatNumber("ImprovedFavoredEnemy") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Waldlufer"))] / 5 + 1 >= 5 ? true : false));
	}

	if (GetFeatNumber("ImprovedHeightenSpell") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("ZaubergradErhhen"), featsyet));
	}

	if (GetFeatNumber("ImprovedKiStrike") == FeatNumber)
	{
		return (((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Mnch"))] - 7) / 3 >= 3 ? true : false) && (TargetStruct->Attributes[4] >= 21 ? true : false));
	}

	if (GetFeatNumber("ImprovedLowLightVision") == FeatNumber)
	{
		return ((TargetStruct->Race == GetRaceNumber("Elf") || TargetStruct->Race == GetRaceNumber("Halbelf") || TargetStruct->Race == GetRaceNumber("Gnom") ? true : false));
	}

	if (GetFeatNumber("ImprovedSpellCasting") == FeatNumber)
	{
		return (
			(IsClass(TargetStruct, GetCharNumber("Barde")) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barde"))] >= 16 ? true : false))
			|| (TargetStruct->HighestSpell >= 9 ? true : false)
			);
	}

	if (GetFeatNumber("ImprovedStunningFist") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("BetubenderSchlag"), featsyet) && (TargetStruct->Attributes[1] >= 19 ? true : false) && (TargetStruct->Attributes[4] >= 19 ? true : false));
	}

	if (GetFeatNumber("ImprovedWhirlwindAttack") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("Wirbelwind"), featsyet) && (TargetStruct->Attributes[1] >= 23 ? true : false));
	}
  
	if (GetFeatNumber("InciteRage") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] >= 15 ? true : false) && (TargetStruct->Attributes[5] >= 25 ? true : false));
	}

	if (GetFeatNumber("InfiniteDeflection") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("Kampfreflexe"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("GeschosseAbwehren"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet) && (TargetStruct->Attributes[1] >= 25 ? true : false));
	}

	if (GetFeatNumber("InfiniteDeflection") == FeatNumber)
	{
		if (!(FeatPresent(TargetStruct, GetFeatNumber("SchnelleWaffenbereitschaft"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("Waffenfokus"), featsyet)))
		{
			return(false);
		}
		for (i = 0;i < TargetStruct->EquipCount;i++)
		{
			if (strstr(TargetStruct->Equipment[i].Name, "rmbrust") != 0)
			{
				return(true);
			}
		}
		return(false);
	}
	
	if (GetFeatNumber("IntensifySpell") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("ZauberVerstrken"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("ZauberMaximieren"), featsyet) && (TargetStruct->HighestSpell >= 9 ? true : false));
	}

	if (GetFeatNumber("KeenStrike") == FeatNumber)
	{
		return (((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Mnch"))] - 7) / 3 >= 3 ? true : false) && (TargetStruct->Attributes[0] >= 23 ? true : false) && (TargetStruct->Attributes[4] >= 23 ? true : false));
	}
	
	if (GetFeatNumber("VopalStrike") == FeatNumber)
	{
		return (((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Mnch"))] - 7) / 3 >= 3 ? true : false) && (TargetStruct->Attributes[0] >= 25 ? true : false) && (TargetStruct->Attributes[4] >= 25 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("KeenStrike"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("BetubenderSchlag"), featsyet));
	}

	if (GetFeatNumber("LegendaryClimber") == FeatNumber)
	{
		return ((TargetStruct->Attributes[1] >= 21 ? true : false));
	}
	
	if (GetFeatNumber("LegendaryTracker") == FeatNumber)
	{
		return ((TargetStruct->Attributes[4] >= 25 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("SpurenLesen"), featsyet));
	}

	if (GetFeatNumber("LegendaryWrestler") == FeatNumber)
	{
		return ((TargetStruct->Attributes[0] >= 21 ? true : false) && (TargetStruct->Attributes[1] >= 21 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet));
	}

	if (GetFeatNumber("MightyRage") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] >= 15 ? true : false) && (TargetStruct->Attributes[0] >= 21 ? true : false) && (TargetStruct->Attributes[2] >= 21 ? true : false));
	}
	
	if (GetFeatNumber("MobileDefense") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("DwarfD"))] >= 9 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("TnzelnderAngriff"), featsyet) && (TargetStruct->Attributes[1] >= 15 ? true : false));
	}

	if (GetFeatNumber("Multispell") == FeatNumber)
	{
		return (FeatPresent(TargetStruct, GetFeatNumber("SchnellZaubern"), featsyet) && (TargetStruct->HighestSpell >= 9 ? true : false));
	}

	if (GetFeatNumber("MusicOfTheGods") == FeatNumber)
	{
		return((TargetStruct->Attributes[5] >= 25 ? true : false));
	}
	
	if (GetFeatNumber("NegativeEnergyBurst") == FeatNumber)
	{
		return((TargetStruct->Attributes[5] >= 25 ? true : false));
	}

	if (GetFeatNumber("OverwhelmingCritical") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Rundumschlag"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterKritischerTreffer"), featsyet) && (TargetStruct->Attributes[0] >= 23 ? true : false));
	}
	
	if (GetFeatNumber("DevastatingCritical") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("OverwhelmingCritical"), featsyet) && (TargetStruct->Attributes[0] >= 25 ? true : false));
	}

	if (GetFeatNumber("PerfectHealth") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("GroeZhigkeit"), featsyet) && (TargetStruct->Attributes[2] >= 25 ? true : false));
	}
	
	if (GetFeatNumber("PerfectTwoWeaponFighting") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("VerbesserterKampfMitZweiWaffen"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("Beidhndigkeit"), featsyet) && (TargetStruct->Attributes[1] >= 25 ? true : false));
	}
	
	if (GetFeatNumber("PlanarTurning") == FeatNumber)
	{
		return((TargetStruct->Attributes[4] >= 25 ? true : false) && (TargetStruct->Attributes[5] >= 25 ? true : false));
	}
	
	if (GetFeatNumber("Polyglot") == FeatNumber)
	{
		return((TargetStruct->Attributes[3] >= 25 ? true : false));
	}

	if (GetFeatNumber("PositiveEnergyAura") == FeatNumber)
	{
		return((TargetStruct->Attributes[5] >= 25 ? true : false));
	}
	
	if (GetFeatNumber("ReactiveCountersong") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kampfreflexe"), featsyet));
	}

	if (GetFeatNumber("ReflectArrows") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("GeschosseAbwehren"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet) && (TargetStruct->Attributes[1] >= 25 ? true : false));
	}
	
	if (GetFeatNumber("RighteousStrike") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("VerbesserterWaffenloserSchlag"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("BetubenderSchlag"), featsyet) && (TargetStruct->Attributes[4] >= 19 ? true : false));
	}
	
	if (GetFeatNumber("RuinousRage") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("HeftigerAngriff"), featsyet) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] >= 15 ? true : false) && (TargetStruct->Attributes[0] >= 25 ? true : false));
	}

	if (GetFeatNumber("SelfConcealment") == FeatNumber)
	{
		return((TargetStruct->Attributes[1] >= 30 ? true : false));
	}

	if (GetFeatNumber("ShatteringStrike") == FeatNumber)
	{
		return(((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Mnch"))] - 7) / 3 >= 3 ? true : false));
	}

	if (GetFeatNumber("SpectralStrike") == FeatNumber)
	{
		return((TargetStruct->HighestSpell >= 9 ? true : false));
	}
	
	if (GetFeatNumber("SpellKnowledge") == FeatNumber)
	{
		return (
			(IsClass(TargetStruct, GetCharNumber("Barde")) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barde"))] >= 16 ? true : false))
			|| (TargetStruct->HighestSpell >= 9 ? true : false)
			);
	}
	
	if (GetFeatNumber("SpellOpportunity") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kampfreflexe"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("SchnellZaubern"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("ImKampfZaubern"), featsyet));
	}

	if (GetFeatNumber("SpellcastingHarrier") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Kampfreflexe"), featsyet));
	}
	
	if (GetFeatNumber("SpontanousDomainAccess") == FeatNumber)
	{
		return((TargetStruct->HighestSpell >= 9 && TargetStruct->Attributes[4] >= 25 ? true : false));
	}

	if (GetFeatNumber("SwarmOfArrows") == FeatNumber)
	{
		return((TargetStruct->Attributes[1] >= 23 ? true : false) && FeatPresent(TargetStruct, GetFeatNumber("SchnellesSchieen"), featsyet));
	}
	
	if (GetFeatNumber("SuperiorInitiative") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("VerbesserteInitiative"), featsyet));
	}

	if (GetFeatNumber("TerrifyingRage") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] >= 15 ? true : false));
	}

	if (GetFeatNumber("ThunderingRage") == FeatNumber)
	{
		return ((TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] >= 15 ? true : false) && (TargetStruct->Attributes[0] >= 25 ? true : false));
	}
	if (GetFeatNumber("TwoWeaponRend") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Beidhndigkeit"), featsyet) && FeatPresent(TargetStruct, GetFeatNumber("VerbesserterKampfMitZweiWaffen"), featsyet));
	}
	if (GetFeatNumber("UncannyAccuracy") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("Przisionsschuss"), featsyet) && (TargetStruct->Attributes[1] >= 21 ? true : false));
	}

	if (GetFeatNumber("UndeadMastery") == FeatNumber)
	{
		return((TargetStruct->Attributes[5] >= 21 ? true : false));
	}

	if (GetFeatNumber("ZoneOfAnimation") == FeatNumber)
	{
		return(FeatPresent(TargetStruct, GetFeatNumber("UndeadMastery"), featsyet) && (TargetStruct->Attributes[5] >= 25 ? true : false));
	}

	if (GetFeatNumber("WidenAuraOfCourage") == FeatNumber)
	{
		return((TargetStruct->Attributes[5] >= 25 ? true : false));
	}
	
	return(true);
}

void DoFeatDep(clsChar* TargetStruct, int FeatNumber)
{
	int i, j, k, l;
	int TempProb[4096];

	ZeroMemory(TempProb, 4096 * sizeof(int));
	TargetStruct->FeatDependancy[FeatNumber] = -2;
	if (TargetStruct->Feats[FeatNumber] == GetFeatNumber("Waffenfokus"))
	{
		for (i = 0;i < TargetStruct->EquipCount;i++)
		{
			if (TargetStruct->Equipment[i].EquipType == EquipWeapon && !(FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, GetEquipNumber(TargetStruct->Equipment[i].Name))))
			{
				TargetStruct->FeatDependancy[FeatNumber] = GetEquipNumber(TargetStruct->Equipment[i].Name);
				return;
			}
		}
		for (i = 0;i < Source.EquipSourceCount;i++)
		{
			if (Source.EquipSource[i].EquipType == EquipWeapon && !(FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, GetEquipNumber(Source.EquipSource[i].Name))))
			{
				TempProb[i] = 1;
			}
		}
		TargetStruct->FeatDependancy[FeatNumber] = AdvancedRand(Source.EquipSourceCount, TempProb, sizeof(int), &Source.EquipSource[0].Name[0], (int) ((char*) &Source.EquipSource[1].Name[0] - (char*) &Source.EquipSource[0].Name[0]), "Waffe fr Talent whlen!\n");
	}

	if (TargetStruct->Feats[FeatNumber] == GetFeatNumber("Waffenspezialisierung") ||
		TargetStruct->Feats[FeatNumber] == GetFeatNumber("Waffenfinesse") ||
		TargetStruct->Feats[FeatNumber] == GetFeatNumber("VerbesserterKritischerTreffer") ||
		TargetStruct->Feats[FeatNumber] == GetFeatNumber("EpicWeaponFocus") ||
		TargetStruct->Feats[FeatNumber] == GetFeatNumber("EpicWeaponSpezialisation") ||
		TargetStruct->Feats[FeatNumber] == GetFeatNumber("OverwhelmingCritical") ||
		TargetStruct->Feats[FeatNumber] == GetFeatNumber("DevastatingCritical"))
	{
		for (i = 0;i < FeatNumber;i++)
		{
			if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfokus")
				&& !FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, TargetStruct->FeatDependancy[i]))
			{
				TargetStruct->FeatDependancy[FeatNumber] = TargetStruct->FeatDependancy[i];
				return;
			}
		}
	}

	if (TargetStruct->Feats[FeatNumber] == GetFeatNumber("Zauberfokus"))
	{
		for (i = 0;i < Source.SchoolSourceCount - 1;i++)
		{
			TempProb[i] = 0;
			if (!FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, i))
			{
				for (l = 0;l < TargetStruct->ClassCount;l++)
				{
					for (j = 0;j <= 9;j++)
					{
						for (k = 0;k < TargetStruct->SpellListCount[l][j];k++)
						{
							if (i == Source.SpellSource[TargetStruct->SpellList[l][j][k]].School)
							{
								TempProb[i] ++;
							}
						}
					}
				}
			}
		}
		if (TargetStruct->Profiled)
		{
			SecureMultiply(&TempProb[Profiles[TargetStruct->Profile].PreferedSchool], TargetStruct->ProfileStrength);
		}
		adverror = 0;
		TargetStruct->FeatDependancy[FeatNumber] = AdvancedRand(Source.SchoolSourceCount - 1, TempProb, sizeof(int), &Source.SchoolSource[0][0], (int) ((char*) &Source.SchoolSource[1][0] - (char*) &Source.SchoolSource[0][0]), "Schule fr Zauberfokus whlen!\n");
		if (TargetStruct->FeatDependancy[FeatNumber] == -1)
		{
			TargetStruct->Feats[FeatNumber] = GetFeatNumber("Abhrtung");
			TargetStruct->FeatDependancy[FeatNumber] = -2;
		}
	}

	if (TargetStruct->Feats[FeatNumber] == GetFeatNumber("VerbesserterZauberfokus")
		|| TargetStruct->Feats[FeatNumber] == GetFeatNumber("EpicSpellFocus"))
	{
		for (i = 0;i < FeatNumber;i++)
		{
			if (TargetStruct->Feats[i] == GetFeatNumber("Zauberfokus")
				&& !FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, TargetStruct->FeatDependancy[i]))
			{
				TargetStruct->FeatDependancy[FeatNumber] = TargetStruct->FeatDependancy[i];
				return;
			}
		}
	}
}

void AddFeat(clsChar* TargetStruct, char* FeatName, int* featsyet, int Dep = -2)
{
	int i;
	for (i = 0;i < *featsyet;i++)
	{
		if ((TargetStruct->Feats[i] == GetFeatNumber(FeatName))
			&& (TargetStruct->FeatDependancy[i] == Dep || TargetStruct->FeatDependancy[i] == -1))
		{
			return;
		}
		if ((TargetStruct->Feats[i] == GetFeatNumber(FeatName))
			&& (Dep == -1))
		{
			TargetStruct->FeatDependancy[i] = -1;
		}
	}
	TargetStruct->Feats[*featsyet] = GetFeatNumber(FeatName);
	TargetStruct->FeatDependancy[*featsyet] = Dep;
	(*featsyet)++;
	TargetStruct->FeatCount++;
}

void DoFeats(clsChar* TargetStruct, int* ProbabilityMod, int Class, bool ClassFeat, int* featsyet, int Epic = 0)
{
	int i, j, k, l;
	int Probability[1024];
	int ProbSave[1024];
	int ProbDone[1024];
	int temp, temp2; 
	bool featok;

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		if (ClassFeat)
		{
			Probability[i] = Source.FeatSource[i].Probability[Class] * TargetStruct->Level;
		}
		else
		{
			Probability[i] = 0;
			for (j = 0;j < TargetStruct->ClassCount;j++)
			{
				Probability[i] += Source.FeatSource[i].Probability[TargetStruct->Classes[j]] * TargetStruct->Levels[j];
			}
		}
		Probability[i] += ProbabilityMod[i] * TargetStruct->Level;
		ProbDone[i] = 0;
		if ((Source.FeatSource[i].Epic > Epic))
		{
			Probability[i] = 0;
		}
		if ((Source.FeatSource[i].Epic < Epic))
		{
			Probability[i] /= 10;
		}
	}

	for (i = *featsyet;i < TargetStruct->FeatCount;i++)
	{
		if (IsClass(TargetStruct, GetCharNumber("ArcaneA")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Waffenfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Waffenfokus");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Kernschuss"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Kernschuss");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Przisionsschuss"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Przisionsschuss");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}

		if (IsClass(TargetStruct, GetCharNumber("BlackG")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Doppelschlag"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Doppelschlag");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}

		if (IsClass(TargetStruct, GetCharNumber("LoreMas")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Zauberfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Zauberfokus");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("VerbesserterZauberfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("VerbesserterZauberfokus");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("ZaubergradErhhen"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("ZaubergradErhhen");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Fertigkeitsfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Fertigkeitsfokus");
				TargetStruct->FeatDependancy[i] = GetSkillNumber("WissenArkanes");
				goto FeatNextA;
			}
		}


		if (IsClass(TargetStruct, GetCharNumber("DwarfD")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Ausweichen"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Ausweichen");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Ausdauer"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Ausdauer");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Abhrtung"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Abhrtung");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}

		if (IsClass(TargetStruct, GetCharNumber("ShadowD")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Ausweichen"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Ausweichen");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Beweglichkeit"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Beweglichkeit");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Kampfreflexe"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Kampfreflexe");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}

		if (IsClass(TargetStruct, GetCharNumber("SilverS")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("KampfMitZweiWaffen"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("KampfMitZweiWaffen");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("Beidhndigkeit"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Beidhndigkeit");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}
		
		if (IsClass(TargetStruct, GetCharNumber("Archm")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Fertigkeitsfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Fertigkeitsfokus");
				TargetStruct->FeatDependancy[i] = GetSkillNumber("Zauberkunde");
				goto FeatNextA;
			}
			if (CountFeats(TargetStruct, GetFeatNumber("Zauberfokus"), i) < 2)
			{
				TargetStruct->Feats[i] = GetFeatNumber("Zauberfokus");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}

		if (IsClass(TargetStruct, GetCharNumber("RedWiz")))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber("Zauberfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("Zauberfokus");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("VerbesserterZauberfokus"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("VerbesserterZauberfokus");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
			if (!FeatPresent(TargetStruct, GetFeatNumber("ZaubergradErhhen"), i))
			{
				TargetStruct->Feats[i] = GetFeatNumber("ZaubergradErhhen");
				DoFeatDep(TargetStruct, i);
				goto FeatNextA;
			}
		}
		
		for (j = 0;j < Source.FeatSourceCount;j++)
		{
			if (FeatPresent(TargetStruct, j, i) == true)
			{
				if (Source.FeatSource[j].MultipleTimes == 0)
				{
					Probability[j] = 0;
				}
				else if (Source.FeatSource[j].MultipleTimes == 1 && ProbDone[j] == 0)
				{
					sprintf(tempout, "Enter 1 to make Feat %s possible again\n", Source.FeatSource[j].Name);
					if (random(1, 8, tempout) > 1)
					{
						Probability[j] = 0;
					}
					ProbDone[j] = 1;
				}
			}
			if (ClassFeat)
			{
				if (Class == GetCharNumber("Kmpfer"))
				{
					if (
						j != GetFeatNumber("Ausweichen")
						&& j != GetFeatNumber("Beweglichkeit")
						&& j != GetFeatNumber("TnzelnderAngriff")
						&& j != GetFeatNumber("Beidhndigkeit")
						&& j != GetFeatNumber("BerittenerKampf")
						&& j != GetFeatNumber("AngriffImVorbeireiten")
						&& j != GetFeatNumber("BerittenerFernkampf")
						&& j != GetFeatNumber("BeherzterSturmangriff")
						&& j != GetFeatNumber("BlindKmpfen")
						&& j != GetFeatNumber("DefensiveKampfweise")
						&& j != GetFeatNumber("VerbessertesEntwaffnen")
						&& j != GetFeatNumber("VerbessertesZuFallBringen")
						&& j != GetFeatNumber("Wirbelwind")
						&& j != GetFeatNumber("HeftigerAngriff")
						&& j != GetFeatNumber("Doppelschlag")
						&& j != GetFeatNumber("Rundumschlag")
						&& j != GetFeatNumber("VerbesserterAnsturm")
						&& j != GetFeatNumber("WaffeZerschmettern")
						&& j != GetFeatNumber("KampfMitZweiWaffen")
						&& j != GetFeatNumber("VerbesserterKampfMitZweiWaffen")
						&& j != GetFeatNumber("Kampfreflexe")
						&& j != GetFeatNumber("Kernschuss")
						&& j != GetFeatNumber("AusVollemLaufSchieen")
						&& j != GetFeatNumber("Fernschuss")
						&& j != GetFeatNumber("Przisionsschuss")
						&& j != GetFeatNumber("SchnellesSchieen")
						&& j != GetFeatNumber("SchnelleWaffenbereitschaft")
						&& j != GetFeatNumber("ExotischeWaffen")
						&& j != GetFeatNumber("VerbesserteInitiative")
						&& j != GetFeatNumber("VerbesserterKritischerTreffer")
						&& j != GetFeatNumber("VerbesserterWaffenloserSchlag")
						&& j != GetFeatNumber("BetubenderSchlag")
						&& j != GetFeatNumber("GeschosseAbwehren")
						&& j != GetFeatNumber("Waffenfinesse")
						&& j != GetFeatNumber("Waffenfokus")
						&& j != GetFeatNumber("Waffenspezialisierung")
						)
					{
						Probability[j] = 0;
					}
				}

				if (Class == GetCharNumber("Magier"))
				{
					if (
						j != GetFeatNumber("GestenlosZaubern")
						&& j != GetFeatNumber("LautlosZaubern")
						&& j != GetFeatNumber("SchnellZaubern")
						&& j != GetFeatNumber("ZauberAusdehnen")
						&& j != GetFeatNumber("ZauberVerstrken")
						&& j != GetFeatNumber("ZauberMaximieren")
						&& j != GetFeatNumber("ZaubergradErhhen")
						&& j != GetFeatNumber("ZauberreichweiteErhhen")
						&& j != GetFeatNumber("Zauberfokus")
						&& j != GetFeatNumber("VerbesserterZauberfokus")
					)
					{
						Probability[j] = 0;
					}
				}

				if (Class == GetCharNumber("PsychicW"))
				{
						if (j != GetFeatNumber("Ausweichen")
						&& j != GetFeatNumber("Beweglichkeit")
						&& j != GetFeatNumber("TnzelnderAngriff")
						&& j != GetFeatNumber("Beidhndigkeit")
						&& j != GetFeatNumber("BerittenerKampf")
						&& j != GetFeatNumber("AngriffImVorbeireiten")
						&& j != GetFeatNumber("BerittenerFernkampf")
						&& j != GetFeatNumber("BeherzterSturmangriff")
						&& j != GetFeatNumber("BlindKmpfen")
						&& j != GetFeatNumber("DefensiveKampfweise")
						&& j != GetFeatNumber("VerbessertesEntwaffnen")
						&& j != GetFeatNumber("VerbessertesZuFallBringen")
						&& j != GetFeatNumber("Wirbelwind")
						&& j != GetFeatNumber("HeftigerAngriff")
						&& j != GetFeatNumber("Doppelschlag")
						&& j != GetFeatNumber("Rundumschlag")
						&& j != GetFeatNumber("VerbesserterAnsturm")
						&& j != GetFeatNumber("WaffeZerschmettern")
						&& j != GetFeatNumber("KampfMitZweiWaffen")
						&& j != GetFeatNumber("VerbesserterKampfMitZweiWaffen")
						&& j != GetFeatNumber("Kampfreflexe")
						&& j != GetFeatNumber("Kernschuss")
						&& j != GetFeatNumber("AusVollemLaufSchieen")
						&& j != GetFeatNumber("Fernschuss")
						&& j != GetFeatNumber("Przisionsschuss")
						&& j != GetFeatNumber("SchnellesSchieen")
						&& j != GetFeatNumber("SchnelleWaffenbereitschaft")
						&& j != GetFeatNumber("ExotischeWaffen")
						&& j != GetFeatNumber("VerbesserteInitiative")
						&& j != GetFeatNumber("VerbesserterKritischerTreffer")
						&& j != GetFeatNumber("VerbesserterWaffenloserSchlag")
						&& j != GetFeatNumber("BetubenderSchlag")
						&& j != GetFeatNumber("GeschosseAbwehren")
						&& j != GetFeatNumber("Waffenfinesse")
						&& j != GetFeatNumber("Waffenfokus")
						&& j != GetFeatNumber("CombatManifestation")
						&& j != GetFeatNumber("PsionicDodge")
						&& j != GetFeatNumber("ImprovedPsychristal")
						&& j != GetFeatNumber("InertialArmor")
						&& j != GetFeatNumber("InnerStrength")
						&& j != GetFeatNumber("Talented")
						&& j != GetFeatNumber("BodyFuel")
						&& j != GetFeatNumber("TriggerPower")
						&& j != GetFeatNumber("MentalAdversary")
						&& j != GetFeatNumber("DisarmMind")
						&& j != GetFeatNumber("MentalLeap")
						&& j != GetFeatNumber("PsionicShot")
						&& j != GetFeatNumber("FellShot")
						&& j != GetFeatNumber("ReturnShot")
						&& j != GetFeatNumber("Sunder")
						&& j != GetFeatNumber("GreatSunder")
						&& j != GetFeatNumber("PsionicWeapon")
						&& j != GetFeatNumber("DeepImpact")
						&& j != GetFeatNumber("PowerPenetration")
						&& j != GetFeatNumber("GreaterPowerPenetration")
						&& j != GetFeatNumber("PsionicBody")
						&& j != GetFeatNumber("PsionicFist")
						&& j != GetFeatNumber("PowerTouch")
						&& j != GetFeatNumber("UnavoidableStrike")
						&& j != GetFeatNumber("PsionicFocus")
						&& j != GetFeatNumber("GreaterPsionicFocus")
						&& j != GetFeatNumber("PsychicBastion")
						&& j != GetFeatNumber("MindTrap")
						&& j != GetFeatNumber("Psychoanalyst")
						&& j != GetFeatNumber("PsychicInquisitor")
						&& j != GetFeatNumber("RapidMetabolism")
						&& j != GetFeatNumber("PsionicMetabolism")
						&& j != GetFeatNumber("SpeedofThought")
						&& j != GetFeatNumber("PsionicCharge")
						&& j != GetFeatNumber("UptheWalls")
						&& j != GetFeatNumber("StandStill")
						&& j != GetFeatNumber("ImKampfZaubern")			
					)
					{
						Probability[j] = 0;
					}
				}
			}
			else
			{
				if (TargetStruct->WeaponArmorShieldFeats == 1)
				{
					for (k = 0;k < TargetStruct->EquipCount;k++)
					{
						if (TargetStruct->Equipment[k].EquipType == EquipWeapon)
						{
							if (TargetStruct->Equipment[k].Type == 0)
							{
								temp2 = GetFeatNumber("EinfacheWaffen");
							}
							else if (TargetStruct->Equipment[k].Type == 1)
							{
								temp2 = GetFeatNumber("KriegsWaffen");
							}
							else
							{
								temp2 = GetFeatNumber("ExotischeWaffen");
							}
				
							featok = false;
							for (l = 0;l < TargetStruct->FeatCount;l++)
							{
								if (TargetStruct->Feats[l] == temp2 && (TargetStruct->FeatDependancy[l] == GetEquipNumber(TargetStruct->Equipment[k].Name) || TargetStruct->FeatDependancy[l] == -1))
								{
									featok = true;
								}
							}
			
							if (!featok)
							{
								TargetStruct->Feats[i] = temp2;
								TargetStruct->FeatDependancy[i] = GetEquipNumber(TargetStruct->Equipment[k].Name);
								if (temp2 == GetFeatNumber("EinfacheWaffen")) {TargetStruct->FeatDependancy[i] = -1;}
								goto FeatNext;
							}
						}

						if (TargetStruct->Equipment[k].EquipType == EquipArmor || TargetStruct->Equipment[k].EquipType == EquipShield)
						{
							if (TargetStruct->Equipment[k].Type == 0)
							{
								temp2 = GetFeatNumber("LeichteRstung");
							}
							else if (TargetStruct->Equipment[k].Type == 1)
							{
								temp2 = GetFeatNumber("MittelschwereRstung");
							}
							else
							{
								temp2 = GetFeatNumber("SchwereRstung");
							}
							
							if (TargetStruct->Equipment[k].EquipType == EquipShield)
							{
								temp2 = GetFeatNumber("Schilde");
							}
	
							if (temp2 == GetFeatNumber("SchwereRstung") && !FeatPresent(TargetStruct, GetFeatNumber("MittelschwereRstung"), *featsyet))
							{
								temp2 = GetFeatNumber("MittelschwereRstung");
							}
	
							if (temp2 == GetFeatNumber("MittelschwereRstung") && !FeatPresent(TargetStruct, GetFeatNumber("LeichteRstung"), *featsyet))
							{
								temp2 = GetFeatNumber("LeichteRstung");
							}

							featok = false;
							for (l = 0;l < TargetStruct->FeatCount;l++)
							{
								if (TargetStruct->Feats[l] == temp2)
								{
									featok = true;
								}
							}
			
							if (!featok)
							{
								TargetStruct->Feats[i] = temp2;
								TargetStruct->FeatDependancy[i] = -2;
								goto FeatNext;
							}
						}
					}
				}

			}
			if (TargetStruct->AttackType[0] != AttackTwoWeapons && TargetStruct->AttackType[1] != AttackTwoWeapons)
			{
				if (
					j == GetFeatNumber("Beidhndigkeit")
					|| j == GetFeatNumber("KampfMitZweiWaffen")
					|| j == GetFeatNumber("VerbesserterKampfMitZweiWaffen")
					)
				{
					Probability[j] = 0;
				}
			}
			if ((TargetStruct->AttackType[0] == AttackBow || TargetStruct->AttackType[0] == AttackNone) && TargetStruct->AttackType[1] == AttackNone)
			{
				if (
					j == GetFeatNumber("HeftigerAngriff")
					|| j == GetFeatNumber("Wirbelwind")
					|| j == GetFeatNumber("TnzelnderAngriff")
					|| j == GetFeatNumber("Doppelschlag")
					|| j == GetFeatNumber("Rundumschlag")
					|| j == GetFeatNumber("AngriffImVorbeireiten")
					|| j == GetFeatNumber("BeherzterSturmangriff")
					|| j == GetFeatNumber("VerbesserterAnsturm")
					|| j == GetFeatNumber("VerbessertesZuFallBringen")
					)
				{
					Probability[j] = 0;
				}
			}
			if (TargetStruct->AttackType[0] != AttackBow && TargetStruct->AttackType[1] != AttackBow)
			{
				if (
					j == GetFeatNumber("Kernschuss")
					|| j == GetFeatNumber("BerittenerFernkampf")
					)
				{
					Probability[j] = 0;
				}
			}
			if (TargetStruct->AttackType[0] == AttackNone)
			{
				if(
					j == GetFeatNumber("Waffenfokus")
					|| j == GetFeatNumber("Waffenspezialisierung")
					)
				{
					Probability[j] = 0;
				}
			}
		}
		temp = 1;

		if (TargetStruct->Profiled)
		{
			for (l = 0;l < Profiles[TargetStruct->Profile].FeatCount;l++)
			{
				if ((!FeatPresent(TargetStruct, Profiles[TargetStruct->Profile].Feats[l].Feat, i)) &&
					FeatPossible(TargetStruct, Profiles[TargetStruct->Profile].Feats[l].Feat, i) &&
					Probability[Profiles[TargetStruct->Profile].Feats[l].Feat] != 0)
				{
					SecureMultiply(&Probability[Profiles[TargetStruct->Profile].Feats[l].Feat], TargetStruct->ProfileStrength);
					break;
				}
			}
		}

		CopyMemory(ProbSave, Probability, Source.FeatSourceCount * sizeof(int));

		do
		{
			if (temp < 1000)
			{
				sprintf(tempout, "Talent %d / %d\n", i, TargetStruct->FeatCount);
				if (ClassFeat)
				{
					sprintf(tempstring, "Bonustalent: %s\n", Source.CharSource[Class].Name);
					strcat(tempout, tempstring);
				}
					
				strcat(tempout, "Talent whlen!\n");
				adverror = 0;
				TargetStruct->Feats[i] = AdvancedRand(Source.FeatSourceCount, &Probability[0], sizeof(int),
					&Source.FeatSource[0].Name[0], (int) ((char*) &Source.FeatSource[1].Name[0] - (char*) &Source.FeatSource[0].Name[0]), tempout);
				if (TargetStruct->Feats[i] == -1)
				{
					goto NoAppropriate;
				}
			}
			else
			{
NoAppropriate:
				if (DebugOutput) {printf("No apropriate Feat found %d\n", i);}
				tempout[0] = 0;
				for (l = 0;l < Source.FeatSourceCount;l++)
				{
					sprintf(tempstring, "%d: %s\n", l, Source.FeatSource[l].Name);
					strcat(tempout, tempstring);
				}
				strcat(tempout, "Select a Feat!\n");
				TargetStruct->Feats[i] = random(0, Source.FeatSourceCount - 1, tempout);
			}
			if (temp > 1)
			{
				Probability[TargetStruct->Feats[i]] = 0;
			}
			temp++;
		}
		while (!FeatPossible(TargetStruct, TargetStruct->Feats[i], i));

		CopyMemory(Probability, ProbSave, Source.FeatSourceCount * sizeof(int));

FeatNextA:;
		DoFeatDep(TargetStruct, i);
FeatNext:;
		ProbDone[TargetStruct->Feats[i]] = 0;
	}
	*featsyet = TargetStruct->FeatCount;
}

void DoClassRaceFeats(clsChar* TargetStruct, int* featsyetA)
{
	int featsyet;

	featsyet = *featsyetA;

	TargetStruct->FeatCount = 0;

	if (IsClass(TargetStruct, GetCharNumber("Waldlufer")))
	{
		AddFeat(TargetStruct, "Beidhndigkeit", &featsyet);
		AddFeat(TargetStruct, "SpurenLesen", &featsyet);
		AddFeat(TargetStruct, "KampfMitZweiWaffen", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("PsychicW")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "SchwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Psion")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
	}

	if (IsClass(TargetStruct, GetCharNumber("Mnch")) && TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Mnch"))] >= 2)
	{
		AddFeat(TargetStruct, "GeschosseAbwehren", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Mnch")))
	{
		AddFeat(TargetStruct, "VerbesserterWaffenloserSchlag", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Mnch")) && TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Mnch"))] >= 6)
	{
		AddFeat(TargetStruct, "VerbessertesZuFallBringen", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Barbar")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Barde")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Kurzbogen"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Kurzschwert"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Langbogen"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Langschwert"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Rapier"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Totschlger"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("KompositKurzbogen"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("KompositLangbogen"));
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Druide")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Dolch"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Sichel"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("HalbSpeer"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Keule"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("KampfStab"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("KurzSpeer"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Schleuder"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Wurfpfeil"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Krummsbel"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Langspeer"));
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Hexenmeister")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
	}

	if (IsClass(TargetStruct, GetCharNumber("Kmpfer")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "SchwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Kleriker")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "SchwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Magier")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Dolch"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("KampfStab"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Keule"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("LeichteArmbrust"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("SchwereArmbrust"));
	}

	if (IsClass(TargetStruct, GetCharNumber("Mnch")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Dolch"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("KampfStab"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Keule"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("LeichteArmbrust"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("SchwereArmbrust"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Beil"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Schleuder"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Wurfspeer"));
		AddFeat(TargetStruct, "ExotischeWaffen", &featsyet, GetEquipNumber("Nunchaku"));
		AddFeat(TargetStruct, "ExotischeWaffen", &featsyet, GetEquipNumber("Siangham"));
	}

	if (IsClass(TargetStruct, GetCharNumber("Paladin")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "SchwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Schurke")))
	{
		AddFeat(TargetStruct, "ExotischeWaffen", &featsyet, GetEquipNumber("Handarmbrust"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("LeichteArmbrust"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Kurzbogen"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("KompositKurzbogen"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Dolch"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Kurzschwert"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("LeichterStreitkolben"));
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Wurfpfeil"));
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Totschlger"));
		if (Source.RaceSource[TargetStruct->Race].Size >= 0)
		{
			AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("KampfStab"));
			AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Keule"));
			AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("SchwereArmbrust"));
			AddFeat(TargetStruct, "KriegsWaffen", &featsyet, GetEquipNumber("Rapier"));
			AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, GetEquipNumber("Morgenstern"));
		}
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
	}

	if (IsClass(TargetStruct, GetCharNumber("Waldlufer")))
	{
		AddFeat(TargetStruct, "EinfacheWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "KriegsWaffen", &featsyet, -1);
		AddFeat(TargetStruct, "LeichteRstung", &featsyet);
		AddFeat(TargetStruct, "MittelschwereRstung", &featsyet);
		AddFeat(TargetStruct, "Schilde", &featsyet);
	}

	*featsyetA = featsyet;
}

void CalculateFeats(clsChar* TargetStruct)
{
	int i, featsyet = 0;
	int *ProbMod;
	ProbMod = new int[Source.FeatSourceCount];

	char WeaponTemp[1024];
	if (ProbMod == 0)
	{
		printf("Memmory Allocation Error...\n");
		quitprog();
	}

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		ProbMod[i] = 0;
	}

	DoClassRaceFeats(TargetStruct, &featsyet);

	if (TargetStruct->Domains[0] == GetDomainNumber("Krieg") || TargetStruct->Domains[1] == GetDomainNumber("Krieg"))
	{
		if (TargetStruct->AttackType != AttackNone && TargetStruct->EquipCount)
		{
			i = GetEquipNumber(TargetStruct->Equipment[0].Name);
			AddFeat(TargetStruct, "Waffenfokus",  &featsyet, i);
			if (TargetStruct->Equipment[0].Type == 0) {strcpy(WeaponTemp, "EinfacheWaffen");i = -1;}
			if (TargetStruct->Equipment[0].Type == 1) {strcpy(WeaponTemp, "KriegsWaffen");}
			if (TargetStruct->Equipment[0].Type == 2) {strcpy(WeaponTemp, "ExotischeWaffen");}
			AddFeat(TargetStruct, WeaponTemp, &featsyet, i);
		}
	}

	TargetStruct->FeatCount += min(TargetStruct->Level, 20) / 3 + 1;
	if (TargetStruct->Race == GetRaceNumber("Mensch") && DummyChar == 0) {TargetStruct->FeatCount++;}

	while (TargetStruct->SpecialAbbilities > 0 && random(1, 3, "1 = Use Special Ability as Feat") == 1)
	{
		TargetStruct->SpecialAbbilities--;
		TargetStruct->FeatCount++;;
	}

	DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet);
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		if (TargetStruct->Classes[i] == GetCharNumber("Kmpfer"))
		{
			TargetStruct->FeatCount += TargetStruct->LevelsClassic[i] / 2 + 1;
			DoFeats(TargetStruct, ProbMod, TargetStruct->Classes[i], 1, &featsyet);
		}
		if (TargetStruct->Classes[i] == GetCharNumber("Magier"))
		{
			TargetStruct->FeatCount += TargetStruct->LevelsClassic[i] / 5;
			DoFeats(TargetStruct, ProbMod, TargetStruct->Classes[i], 1, &featsyet);
		}
		if (TargetStruct->Classes[i] == GetCharNumber("PsychicW"))
		{
			TargetStruct->FeatCount += max(0, (TargetStruct->LevelsClassic[i] - 2) / 3);
			TargetStruct->FeatCount += min(2, TargetStruct->LevelsClassic[i]);
			DoFeats(TargetStruct, ProbMod, TargetStruct->Classes[i], 1, &featsyet);
		}
		if (TargetStruct->Classes[i] == GetCharNumber("RedWiz") && TargetStruct->Levels[i] > 5)
		{
			TargetStruct->FeatCount++;
			DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet);
		}
	}

	TargetStruct->FeatCount += max(0, TargetStruct->Level - 18) / 3;
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		if (TargetStruct->Classes[i] == GetCharNumber("Kmpfer"))
		{
			TargetStruct->FeatCount += (TargetStruct->Levels[i] - TargetStruct->LevelsClassic[i]) / 2;
		}
		if (TargetStruct->Classes[i] == GetCharNumber("Barde")
			|| TargetStruct->Classes[i] == GetCharNumber("Kleriker")
			|| TargetStruct->Classes[i] == GetCharNumber("Paladin")
			|| TargetStruct->Classes[i] == GetCharNumber("Waldlufer")
			|| TargetStruct->Classes[i] == GetCharNumber("Hexenmeister")
			|| TargetStruct->Classes[i] == GetCharNumber("RedWiz")
			|| TargetStruct->Classes[i] == GetCharNumber("Magier")
			|| TargetStruct->Classes[i] == GetCharNumber("BlackG")
			|| TargetStruct->Classes[i] == GetCharNumber("DwarfD")
			|| TargetStruct->Classes[i] == GetCharNumber("LoreMas")
			|| TargetStruct->Classes[i] == GetCharNumber("ShadowD")
			|| TargetStruct->Classes[i] == GetCharNumber("PsychicW"))
		{
			TargetStruct->FeatCount += (TargetStruct->Levels[i] - TargetStruct->LevelsClassic[i]) / 3;
		}
		if (TargetStruct->Classes[i] == GetCharNumber("Druide")
			|| TargetStruct->Classes[i] == GetCharNumber("Barbar")
			|| TargetStruct->Classes[i] == GetCharNumber("Schurke")
			|| TargetStruct->Classes[i] == GetCharNumber("ArcaneA")
			|| TargetStruct->Classes[i] == GetCharNumber("SilverS")
			|| TargetStruct->Classes[i] == GetCharNumber("Assasin")
			|| TargetStruct->Classes[i] == GetCharNumber("DragonD")
			|| TargetStruct->Classes[i] == GetCharNumber("Psion"))
		{
			TargetStruct->FeatCount += (TargetStruct->Levels[i] - TargetStruct->LevelsClassic[i]) / 4;
		}
		if (TargetStruct->Classes[i] == GetCharNumber("Mnch"))
		{
			TargetStruct->FeatCount += (TargetStruct->Levels[i] - TargetStruct->LevelsClassic[i]) / 5;
		}
	}
	DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet, 1);

	delete[] ProbMod;
	if (IsClass(TargetStruct, GetCharNumber("PsychicW")) && TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("PsychicW"))] >= 6)
	{
		for (i = 0;i < TargetStruct->FeatCount;i++)
		{
			if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfokus"))
			{
				TargetStruct->Feats[TargetStruct->FeatCount] = GetFeatNumber("Waffenspezialisierung");
				TargetStruct->FeatDependancy[TargetStruct->FeatCount] = TargetStruct->FeatDependancy[i];
				TargetStruct->FeatDone[TargetStruct->FeatCount] = 0;
				TargetStruct->FeatCount++;
			}
		}
	}
}

void SetMin(int* val, int minval)
{
	*val = min(*val, minval);
}

void SetFeatSkills(clsChar* TargetStruct)
{
	if (FeatPresent(TargetStruct, GetFeatNumber("BerittenerKampf"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Reiten")], 1);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("AutomaticQuickenSpell"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("AutomaticSilentSpell"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 24);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("AutomaticStillSpell"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 27);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("BaneOfEnemies"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Naturkunde")], 24);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("DeathOfEnemies"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Naturkunde")], 30);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("BeastWildShape"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("WissenNatur")], 24);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("PlantWildShape"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("WissenNatur")], 24);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("VerminWildShape"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("WissenNatur")], 27);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("DragonWildShape"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("WissenNatur")], 30);
	}
	
	if (FeatPresent(TargetStruct, GetFeatNumber("DefeningSong"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 24);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("HinderingSong"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 27);
	}
	
	if (FeatPresent(TargetStruct, GetFeatNumber("DistantShot"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Entdecken")], 20);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("EpicEvasion"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Turnen")], 30);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("EpicInspiration"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 30);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("LegendaryCommander"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Diplomatie")], 30);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("EpicSpellcasting"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 24);
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("WissenArkanes")], 24);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("IgnoreMaterialComponents"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 25);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("ImprovedHeightenSpell"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 20);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("ImprovedMetamagic"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("InspireExcellence"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("LastingInspiration"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 25);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("LegendaryClimber"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Balancieren")], 12);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("LegendaryTracker"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Naturkunde")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("LegendaryWrestler"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Entfesselungsknstler")], 15);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("MusicOfTheGods"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("RangedInspiration"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 25);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("RapidInspiration"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Auftreten")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("SelfConcealment"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Verstecken")], 30);
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Turnen")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("SpellOpportunity"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 25);
	}

	if (FeatPresent(TargetStruct, GetFeatNumber("SpontanousDomainAccess"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Zauberkunde")], 30);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("TerrifyingRage"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Einschchtern")], 25);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("TrapSense"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Suchen")], 25);
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Entdecken")], 25);
	}
	if (FeatPresent(TargetStruct, GetFeatNumber("UncannyAccuracy"), TargetStruct->FeatCount))
	{
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber("Entdecken")], 25);
	}
}

void SetFeatSkillsA(clsChar* TargetStruct)
{
	int i;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		if (TargetStruct->Feats[i] == GetFeatNumber("Fertigkeitsfokus") || TargetStruct->Feats[i] == GetFeatNumber("EpicSkillFocus"))
		{
			sprintf(tempout, "Fertigkeit fr Fertigkeitsfokus whlen!\n");
			if (TargetStruct->SkillCount == 0)
			{
				TargetStruct->FeatDependancy[i] = random(0, Source.SkillSourceCount - 1, tempout);
			}
			else
			{
				TargetStruct->FeatDependancy[i] = TargetStruct->Skills[random(0, TargetStruct->SkillCount - 1, tempout)];
			}
		}
	}
}

void DoFeatEffects(clsChar* TargetStruct)
{
	int i, j, k;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		if (TargetStruct->Feats[i] == GetFeatNumber("Abhrtung"))
		{
			TargetStruct->Life;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Beweglichkeit"))
		{
			strcat(TargetStruct->CharText, "+4 RK gegen Gelegenheitsangriffe\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Ausweichen") || TargetStruct->Feats[i] == GetFeatNumber("PsionicDodge"))
		{
			strcat(TargetStruct->CharText, "+1 RK gegen einen Gegner\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Beidhndigkeit"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				TargetStruct->Equipment[j].AttackBonusA -= 4;
				if (TargetStruct->Equipment[j].TwoWeaponSecond == 1)
				{
					TargetStruct->Equipment[j].AttackBonus += 4;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("KampfMitZweiWaffen"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (TargetStruct->Equipment[j].TwoWeapon == 1)
				{
					TargetStruct->Equipment[j].AttackBonus += 2;
				}
			}
			TargetStruct->Attacks2++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("VerbesserterKampfMitZweiWaffen"))
		{		
			TargetStruct->Attacks2++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("VerbesserteInitiative"))
		{
			TargetStruct->InitiativeRest += 4;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("VerbesserterKritischerTreffer"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].CriticalMultiplier2++;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("BlitzschnelleReflexe"))
		{
			TargetStruct->RWRefRest += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EisernerWille"))
		{
			TargetStruct->RWWilRest += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GroeZhigkeit"))
		{
			TargetStruct->RWZaehRest += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImKampfZaubern"))
		{
			int zaubern = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Konzentration"))
				{
					
					TargetStruct->SkillLevels[j] += 4;
					zaubern = 1;
				}
			}
			if (zaubern == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Konzentration");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 4;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DurschschlagendeZauber"))
		{
			TargetStruct->againstMR += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("VerbesserteDurschschlagende"))
		{
			TargetStruct->againstMR += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Fertigkeitsfokus"))
		{
			int skillfound = 0;
			TargetStruct->SkillPoints += 2;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->SkillLevels[j] += 2;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = TargetStruct->FeatDependancy[i];
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 2;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfokus"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].AttackBonus++;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Waffenspezialisierung"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].Damage3 += 2;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfinesse"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].AttackBonus -= TargetStruct->Mods[0];
					TargetStruct->Equipment[j].AttackBonus += TargetStruct->Mods[1];
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Kampfreflexe"))
		{
			TargetStruct->AttacksOpportunity += GreaterZero(TargetStruct->Mods[1]);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("InnerStrength"))
		{
			TargetStruct->PowerPoints++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("PowerPenetration"))
		{
			TargetStruct->againstPR += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreaterPowerPenetration"))
		{
			TargetStruct->againstPR += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ZustzlichesVertreiben"))
		{}
		else if (TargetStruct->Feats[i] == GetFeatNumber("PsionicBody"))
		{
			if (IsClass(TargetStruct, GetCharNumber("Psion")))
			{
				if (TargetStruct->Mods[TargetStruct->MainDisciple] > TargetStruct->Mods[2])
				{
					TargetStruct->LifeBonus += TargetStruct->Mods[TargetStruct->MainDisciple];
					TargetStruct->LifeBonus -= TargetStruct->Mods[2];
				}
			}
			for (j = 0;j < TargetStruct->FeatCount;j++)
			{
				if (TargetStruct->Feats[j] == GetFeatNumber("DelayPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("EnlargePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("ExtendPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("HeightenPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("HidePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("MasterDorje")
					|| TargetStruct->Feats[j] == GetFeatNumber("MaximizePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("QuickenPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("TwinPower"))
				{
					TargetStruct->LifeBonus++;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ArmorSkinn"))
		{
			TargetStruct->ACRest += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("BulwarkOfDefense")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DamageReduction"))
		{
			strcat(TargetStruct->CharText, "Schadensreduktion 3/-\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DefeningSong"))
		{
			strcat(TargetStruct->CharText, "You can use song or poetics to temporarily deafen all enemies within a 30-foot spread from you. A successful Fortitude  save (DC = 10 plus one-half your level plus your Charisma modifier) negates the effect. The deafening effect lasts for as long as you continue the deafening song. You can choose to exclude any characters from this effect (usually your allies).\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DeathOfEnemies"))
		{
			sprintf(tempout, "Erzfeinde mssen bei kritischem Treffer Zhigkeitswurf (SG %d) schaffen oder sterben\n", 10 + TargetStruct->Level / 2 + TargetStruct->Mods[4]);
			strcat(TargetStruct->CharText, tempout);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DevastatingCritical"))
		{
			sprintf(tempout, "Gegner mssen bei kritischem Treffer Zhigkeitswurf (SG %d) schaffen oder sterben\n", 10 + TargetStruct->Level / 2 + TargetStruct->Mods[0]);
			strcat(TargetStruct->CharText, tempout);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DireCharge"))
		{
			strcat(TargetStruct->CharText, "Kann vollen Angriff als Gelegenheitsangriff ausfhren\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DistantShot"))
		{
			strcat(TargetStruct->CharText, "Kein Abzge auf Fernkampfwaffen unabhngig von Reichweite und Entfernung\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EnergyResistance"))
		{
			sprintf(tempout, "+10 Wiederstand gegen %s\n", GetElement(random(0, 2, "Element fr Wiederstand?")));
			strcat(TargetStruct->CharText, tempout);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicEvasion"))
		{
			strcat(TargetStruct->CharText, "Kann einmal pro Runde einem Angriff des fr Ausweichen ausgewhlten Gegners Entrinnen\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicFortitude"))
		{
			TargetStruct->RWZaehRest += 4;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicInspiration"))
		{
			strcat(TargetStruct->CharText, "All bonuses granted by your bardic music inspiration abilities are doubled\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicProwess"))
		{
			TargetStruct->GAMeleeRest++;
			TargetStruct->GAShotRest++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicReflexes"))
		{
			TargetStruct->RWRefRest += 4;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicReputation"))
		{
			int skillfound;
			skillfound = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Bluffen"))
				{
					TargetStruct->SkillLevels[j] += 4;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Bluffen");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 4;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
			skillfound = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Diplomatie"))
				{
					TargetStruct->SkillLevels[j] += 4;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Diplomatie");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 4;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
			skillfound = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("InformationenSammeln"))
				{
					TargetStruct->SkillLevels[j] += 4;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("InformationenSammeln");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 4;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
			skillfound = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Einschchtern"))
				{
					TargetStruct->SkillLevels[j] += 4;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Einschchtern");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 4;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
			skillfound = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Auftreten"))
				{
					TargetStruct->SkillLevels[j] += 4;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Auftreten");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 4;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicSkillFocus"))
		{
			int skillfound = 0;
			TargetStruct->SkillPoints += 10;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->SkillLevels[j] += 10;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = TargetStruct->FeatDependancy[i];
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 10;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicSpellPenetration"))
		{
			TargetStruct->againstMR += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicSpellcasting"))
		{
			k = 0;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("WissenArkanes"))
				{
					k = TargetStruct->SkillLevels[j] / 10;
					break;
				}
			}
			sprintf(tempout, "Kann pro Tag %d Epic Spells\n", k);
			strcat(TargetStruct->CharText, tempout);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicToughness"))
		{
			TargetStruct->LifeBonus += 20;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicWeaponFocus"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].AttackBonus += 2;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicWeaponSpezialisation"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].Damage3 += 4;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicWill"))
		{
			TargetStruct->RWWilRest += 4;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("FleetOfFoot"))
		{
			TargetStruct->Range += 9;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatCharisma"))
		{
			TargetStruct->Attributes[5]++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatConstitution"))
		{
			TargetStruct->Attributes[2]++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatDexterity"))
		{
			TargetStruct->Attributes[1]++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatIntelligence"))
		{
			TargetStruct->Attributes[3]++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatStrength"))
		{
			TargetStruct->Attributes[0]++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatWisdom"))
		{
			TargetStruct->Attributes[4]++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatSmiting")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatInspiration"))
		{
			strcat(TargetStruct->CharText, "The number of allies you can affect with your inspire comptence or inspire greatness bardic music ability doubles. When  inspiring competence in multiple allies, you can choose different skills to inspire for different allies\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("HinderingSong"))
		{
			strcat(TargetStruct->CharText, "You can use song or poetics to hinder enemy spellcasters within a 30-foot spread from you. To successfully cast a spell  within  this area, the spellcaster must make a Concentration check  as if she were casting defensively, and all such  checks suffer a penalty equal to half your level. You can choose to exclude any characters from this effect (usually your allies).\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("HolyStrike"))
		{
			strcat(TargetStruct->CharText, "+2W6 Schaden gegen Bses\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedArrowOfDeath")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedAuraOfCourage")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedCombatReflexes"))
		{
			TargetStruct->AttacksOpportunity = 1024;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedDeathAttack")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedSpellResistance"))
		{
			TargetStruct->MRBonus += 2;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("MightyRage")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("PerfectHealth"))
		{
			strcat(TargetStruct->CharText, "Immun gegen alle Krankheiten und Gifte mit SG < 25\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("PerfectTwoWeaponFighting"))
		{
			TargetStruct->Attacks2 = TargetStruct->Attacks;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("SuperiorInitiative"))
		{
			TargetStruct->InitiativeRest += 4;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Psychoanalyst"))
		{
			int skillfound = 0;
			TargetStruct->SkillPoints += 4;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Diplomatie"))
				{
					TargetStruct->SkillLevels[j] += 2;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Diplomatie");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 2;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
			skillfound = 0;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("Bluffen"))
				{
					TargetStruct->SkillLevels[j] += 2;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = GetSkillNumber("Bluffen");
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 2;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedPsychristal"))
		{
			TargetStruct->CrystalCount++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("LeichteRstung")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("MittelschwereRstung")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("SchwereRstung")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Schilde")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EinfacheWaffen")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("KriegsWaffen")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ExotischeWaffen")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Kernschuss"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (TargetStruct->Equipment[j].Type == AttackBow)
				{
					TargetStruct->Equipment[j].AttackBonus++;
					TargetStruct->Equipment[j].Damage3++;
				}
			}
		}
		else
		{
			TargetStruct->FeatDone[i] = 1;
		}
	}
	
	j = -1;
	k = 0;
	for (i = 0;i < TargetStruct->EquipCount;i++)
	{
		if (!(
			FeatPresent(TargetStruct, GetFeatNumber("EinfacheWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			|| FeatPresent(TargetStruct, GetFeatNumber("KriegsWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			|| FeatPresent(TargetStruct, GetFeatNumber("ExotischeWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			))
		{
			TargetStruct->Equipment[i].AttackBonus -= 4;
		}
		if (TargetStruct->Equipment[i].EquipType == EquipArmor && strcmp(TargetStruct->Equipment[i].Name, "Magierrobe") != 0)
		{
			j = max(j, TargetStruct->Equipment[i].Type);
		}
		if (TargetStruct->Equipment[i].EquipType == EquipShield)
		{
			k = 1;
		}
	}
	if (j >= 0)
	{
		if (!(FeatPresent(TargetStruct, GetFeatNumber(GetTypeName(EquipArmor, j)), TargetStruct->FeatCount)))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				TargetStruct->Equipment[j].AttackBonus -= 4;
			}
			TargetStruct->ArmorMalus += 4;
		}
	}
	if (k == 1 && (!(FeatPresent(TargetStruct, GetFeatNumber("Schilde"), TargetStruct->FeatCount))))
	{
		for (j = 0;j < TargetStruct->EquipCount;j++)
		{
			TargetStruct->Equipment[j].AttackBonus -= 4;
		}
		TargetStruct->ArmorMalus += 4;
	}
}

void StripFeats(clsChar* TargetStruct)
{
	int i;
	int j;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		for (j = 0;j < TargetStruct->FeatCount;j++)
		{
			if (i != j)
			{
				if (TargetStruct->Feats[i] == TargetStruct->Feats[j])
				{
					if (TargetStruct->FeatDependancy[i] == TargetStruct->FeatDependancy[j] ||
						TargetStruct->FeatDependancy[i] == -1)
					{
						TargetStruct->Feats[j] = TargetStruct->Feats[TargetStruct->FeatCount - 1];
						TargetStruct->FeatDependancy[j] = TargetStruct->FeatDependancy[TargetStruct->FeatCount - 1];
						TargetStruct->FeatDone[j] = TargetStruct->FeatDone[TargetStruct->FeatCount - 1];
						TargetStruct->FeatCount--;
					}
				}
			}
			if (i >= TargetStruct->FeatCount)
			{
				break;
			}
		}
	}
}